#pragma once

#include <ntifs.h>


typedef struct _SERVICE_DESCRIPTOR_TABLE {
	/*
	* Table containing cServices elements of pointers to service handler
	* functions, indexed by service ID.
	*/
	PLONG   ServiceTable;
	/*
	* Table that counts how many times each service is used. This table
	* is only updated in checked builds.
	*/
	PULONG  CounterTable;
	/*
	* Number of services contained in this table.
	*/
	ULONG  TableSize;
	/*
	* Table containing the number of bytes of parameters the handler
	* function takes.
	*/
	PUCHAR  ArgumentTable;
} SERVICE_DESCRIPTOR_TABLE, *PSERVICE_DESCRIPTOR_TABLE;

typedef struct _SERVICE_DESCRIPTOR_TABLE_SHADOW {
	PLONG   SsdtServiceTable;
	PULONG  SsdtCounterTable;
	ULONG	SsdtTableSize;
	PUCHAR  SsdtArgumentTable;

	PLONG   ServiceTable;
	PULONG  CounterTable;
	ULONG	TableSize;
	PUCHAR  ArgumentTable;
} SERVICE_DESCRIPTOR_TABLE_SHADOW, *PSERVICE_DESCRIPTOR_TABLE_SHADOW;


NTKERNELAPI NTSTATUS NtQueryInformationThread(
	_In_      HANDLE          ThreadHandle,
	_In_      THREADINFOCLASS ThreadInformationClass,
	_Inout_   PVOID           ThreadInformation,
	_In_      ULONG           ThreadInformationLength,
	_Out_opt_ PULONG          ReturnLength
	);


NTKERNELAPI NTSTATUS NtQuerySystemInformation(
	ULONG SystemInformationClass,
	PVOID                    SystemInformation,
	ULONG                    SystemInformationLength,
	PULONG                   ReturnLength);


NTKERNELAPI PVOID PsGetProcessWin32Process(PEPROCESS Process);

//
// From assembly
//
VOID _syscall64();
VOID OpcodeJmpMemory();
VOID SsdtOpcodeJmpMemory();
VOID ShadowSsdtOpcodeJmpMemory();

NTSTATUS InitializeFakeSyscall();

NTSTATUS FixSyscall64RelativeAddress(ULONG_PTR MdlVa,
	ULONG_PTR SyscallOrigin,
	SIZE_T Length);

VOID FixOpcodeCmpRsiInDriver(ULONG_PTR AddressInDriver,
	ULONG_PTR AddressInSystem,
	ULONG_PTR AddressInMdl,
	ULONG64 Offset,
	PULONG_PTR Ptr);

VOID FixOpcodeCallInDriver(ULONG_PTR AddressInDriver,
	ULONG_PTR AddressInSystem,
	ULONG_PTR AddressInMdl,
	ULONG64 Offset,
	PULONG_PTR Ptr);

VOID FixOpcodeCmovaeRsiInDriver(ULONG_PTR AddressInDriver,
	ULONG_PTR AddressInSystem,
	ULONG_PTR AddressInMdl,
	ULONG64 Offset,
	PULONG_PTR Ptr);

VOID FixOpcodeTestInDriver(ULONG_PTR AddressInDriver,
	ULONG_PTR AddressInSystem,
	ULONG_PTR AddressInMdl,
	ULONG64 Offset,
	PULONG_PTR Ptr);

NTSTATUS RebuildSystemServiceTable(ULONG_PTR DriverAddress,
	ULONG_PTR SystemAddress,
	ULONG_PTR MdlAddress,
	ULONG_PTR leaR10Offset,
	ULONG_PTR leaR11Offset,
	ULONG_PTR leaRdiOffset);

VOID LookupAWin32Process(PEPROCESS *eprocess);

NTSTATUS RebuiltShadowSsdt(ULONG_PTR SysSsdtAddress,
	ULONG_PTR SysShadowSsdtAddress);
